# Simulation
Das hier ist das Repository zu dem ÖFIT-Impuls ["Wirkungen verstehen und nutzen: Agentenbasierte Simulationen für den öffentlichen Sektor"](https://www.oeffentliche-it.de/publikationen/agentenbasierte-simulationen-fuer-den-oeffentlichen-sektor)

## Der Impuls

In unserem Impuls beleuchten wir die Rolle von Computersimulationen im öffentlichen Sektor. 
Wir probieren aus, ob diese digitalen Werkzeuge auch außerhalb der Wissenschaft nützlich und zugänglich genug sind, um sie selbst zu erstellen. 


Unser Ansatz ist praxisnah: Wir entwickelten eine Simulation zur Nutzung einer eID in klar nachvollziehbaren Schritten. 
Der Kernmechanismus in der Simulation ist die Einstellung der Bürger zur eID, die wir als Agenten modellieren. 
Diese Einstellung formt sich durch Erfahrungen bei Behördenkontakten und beeinflusst, ob eine eID (erneut) beantragt wird. 
Details zur Modellierung und den Simulationen finden Sie im Impuls. 

Die Simulationen haben wir in der Simulationsumgebung [NetLogo](https://ccl.northwestern.edu/netlogo/) erstellt und hier dokumentiert. 
Zudem untersuchten wir, ob KI-Chatbots bei der Programmierung unterstützen können; auch diese Dialoge sind hier im Repository dokumentiert. 

Entdecken Sie mit uns die Welt der Simulation. Laden Sie unsere Simulationen herunter und probieren Sie sie aus!


## Repo-Struktur

### code
Im Ordner "code" findet sich der Quellcode in NetLogo für die im Impuls beschriebene agentenbasierte Simulation zur Verbreitung der eID. 
Die Simulation wurde in drei Iterationen entwickelt. Für den Abschluss jeder Iteration findet sich der entsprechende NetLogo-Code, erkennbar durch die Versionsnummer im Namen. 
Für genauere Beschreibung der Iterationen wird auf das Impulspapier verwiesen.

### screenshots
Im Ordner "screenshots" finden sich die Originalscreenshots, die für das Impulspapier graphisch aufbereitet worden sind. 


### ki-dialoge-initial
Hier finden sich die ersten Versuche zur Programmierung mithilfe verschiedener Chatbots (
    [ChatGPT](https://chatgpt.com/), 
    [Copilot](https://copilot.microsoft.com/) (in MS Bing), 
    [Gemini](https://gemini.google.com/)
    ).
Mithilfe dieser Dialoge sollte herausgefunden werden, ob es überhaupt auf einfache Art möglich ist, in [Python](https://www.python.org/) oder in [NetLogo](https://ccl.northwestern.edu/netlogo/) mithilfe eines KI-Chatbots Simulationen zu erstellen
Die Dialoge sind dokumentiert und teilweise annotiert. 
Aus technischen Gründen liegen die Dialoge mit den verschiedenen Chatbots in unterschiedlichen Format vor. 
Aus diesen Dia
Nähere Angaben zu den einzelnen Simulationen bzw. deren Status (einige Simulation enthalten Fehler und sind nicht lauffähig) finden sich in der README-Datei des Verzeichnisses.


### ki-dialoge-claude
Die erfolgreichsten Versuche zur Programmierung gelangen mit Claude [https://claude.ai/], daher sind sie in einem eigenen Verzeichnis zusammengefasst.
Auch hier sind die Dialoge aufgezeichnet, Sourcecode als einzelne Dateien abgelegt und ggf. ein Screenshot zur Illustration hinzugefügt. 
Details wieder in der README-Datei.  



## Autoren
[Jan Dennis Gumz](https://www.oeffentliche-it.de/team?name=jan-dennis-gumz) <br>
[Jens Tiemann](https://www.oeffentliche-it.de/team?name=jens-tiemann) <br>
[Dr. Mike Weber](https://www.oeffentliche-it.de/team?name=mike-weber) <br>
[Dorian Wachsmann](https://www.oeffentliche-it.de/team?name=dorian-wachsmann) <br>


## Lizenz

CC-BY

## Projekt Status
Abgeschlossen.
