import random
import matplotlib.pyplot as plt
import numpy as np

# Simulationsparameter
num_agents = 500
num_initial_users = 10
adoption_radius = 2
adoption_probability = 0.5
num_iterations = 100

# Initialisierung
agents = [(random.randint(-50, 50), random.randint(-50, 50), False) for _ in range(num_agents)]
for i in random.sample(range(num_agents), num_initial_users):
    agents[i] = (agents[i][0], agents[i][1], True)

total_users = [sum(user for _, _, user in agents)]
new_users = [0]

# Simulation
for _ in range(num_iterations):
    new_adopters = []
    for i, (x, y, user) in enumerate(agents):
        if not user:
            neighbors = [(x2, y2, user2) for x2, y2, user2 in agents if (x2 - x) ** 2 + (y2 - y) ** 2 <= adoption_radius ** 2]
            if any(user2 for _, _, user2 in neighbors) and random.random() < adoption_probability:
                new_adopters.append(i)
    for i in new_adopters:
        agents[i] = (agents[i][0], agents[i][1], True)
    total_users.append(sum(user for _, _, user in agents))
    new_users.append(len(new_adopters))

# Visualisierung
plt.figure(figsize=(10, 6))
plt.subplot(2, 1, 1)
plt.plot(total_users)
plt.title("Gesamtzahl der Nutzer")
plt.xlabel("Iteration")
plt.ylabel("Anzahl Nutzer")

plt.subplot(2, 1, 2)
plt.plot(new_users)
plt.title("Neue Nutzer pro Iteration")
plt.xlabel("Iteration")
plt.ylabel("Anzahl neue Nutzer")

plt.tight_layout()
plt.show()
