import random
import matplotlib.pyplot as plt
import numpy as np

# Simulationsparameter
num_citizens = 1000
mean_attitude = 50
stddev_attitude = 20

# Initialisierung
attitudes = np.random.normal(mean_attitude, stddev_attitude, num_citizens)
attitudes = np.clip(np.round(attitudes), 0, 100)  # Runden und begrenzen auf Bereich 0-100

# Visualisierung
plt.figure(figsize=(8, 6))
plt.hist(attitudes, bins=20, edgecolor='black', density=True)
plt.title("Verteilung der Einstellungen gegenüber dem Dienst")
plt.xlabel("Einstellung (0-100)")
plt.ylabel("Dichte")

plt.show()
